diff --git a/encoder/slicetype.c b/encoder/slicetype.c
index 0d87908..21c27e5 100644
--- a/encoder/slicetype.c
+++ b/encoder/slicetype.c
@@ -105,7 +105,7 @@ static NOINLINE unsigned int x264_weight_cost( x264_t *h, x264_frame_t *fenc, pi
     int i_lines = fenc->i_lines_lowres;
     int i_width = fenc->i_width_lowres;
     pixel *fenc_plane = fenc->lowres[0];
-    ALIGNED_ARRAY_8( pixel, buf,[8*8] );
+    ALIGNED_ARRAY_8( pixel, buf,[8*8*2] );
     int pixoff = 0;
     int i_mb = 0;
 
@@ -114,8 +114,8 @@ static NOINLINE unsigned int x264_weight_cost( x264_t *h, x264_frame_t *fenc, pi
         for( int y = 0; y < i_lines; y += 8, pixoff = y*i_stride )
             for( int x = 0; x < i_width; x += 8, i_mb++, pixoff += 8)
             {
-                w->weightfn[8>>2]( buf, 8, &src[pixoff], i_stride, w, 8 );
-                cost += X264_MIN( h->pixf.mbcmp[PIXEL_8x8]( buf, 8, &fenc_plane[pixoff], i_stride ), fenc->i_intra_cost[i_mb] );
+                w->weightfn[8>>2]( buf, 16, &src[pixoff], i_stride, w, 8 );
+                cost += X264_MIN( h->pixf.mbcmp[PIXEL_8x8]( buf, 16, &fenc_plane[pixoff], i_stride ), fenc->i_intra_cost[i_mb] );
             }
         /* Add cost of weights in the slice header. */
         int numslices;
